#include "PreCompiledHeaders.hh"
#include "Lib/JsonBuilder.hh"

using namespace Vivy;

QJsonArray
JsonBuilder::createOrderedJsonObject(
    std::initializer_list<QPair<QString, QJsonValue>> elements) noexcept
{
    QJsonArray ret;
    int index = 0;

    for (const QPair<QString, QJsonValue> &elem : elements) {
        ret.insert(index, QJsonObject({ elem }));
        ++index;
    }

    return ret;
}

QJsonDocument
JsonBuilder::createOrderedJsonDocument(
    std::initializer_list<QPair<QString, QJsonValue>> elements) noexcept
{
    return QJsonDocument(createOrderedJsonObject(elements));
}
