#pragma once

#include "PreCompiledHeaders.hh"

namespace Vivy::Script
{
// The options
class ScriptOption {
    enum class Type { String, Number, Boolean };

private:
    std::string string;
    double number;
    bool boolean;

    Type type;

public:
    ScriptOption(const std::string &) noexcept;
    ScriptOption(const std::string_view) noexcept;
    ScriptOption(bool) noexcept;
    ScriptOption(double) noexcept;

    std::string *getString() noexcept;
    double *getNumber() noexcept;
    bool *getBoolean() noexcept;

    std::string_view getSignature() const noexcept;
};
}
