#pragma once

#include <PreCompiledHeaders.hh>

#include "Lib/Ass/Ass.hh"
#include "TimingSeparator.hh"
#include "TimingSyl.hh"

namespace Vivy
{
class TimingLine final : public QGraphicsObject {
    Q_OBJECT
public:
    explicit TimingLine(Ass::Line&, int, QGraphicsItem * = nullptr);

    QRectF boundingRect() const override;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget) override;

private:
    Ass::Line& line;
    QVector<TimingSeparator *> seps;
    QVector<TimingSyl *> timingSyls;
    int lineIndex;

    qreal tempOffset{ 0 };

public:
    qreal requestMove(int, qreal);

signals:
    void lineChanged(int);

public slots:
    void timingSeparatorHasChanged(int, qreal);
    void sepEnterPress(int);
    void sepExitPress(int);
    void onParamsChanged();
};

}
